# -*- coding: utf-8 -*-
"""
Created on Sat Mar 30 09:31:48 2024

@author: SA-Lenovo
"""

import numpy as np
import matplotlib.pyplot as plt

 
M = 1.0         # Sun
m = 3.0e-6      # Earth
G = 1.0

xS = np.array([0, 0, 0])    # the position vector of the Sun
xE = np.array([1, 0, 0])    # the position vector of the Earth
vS = np.array([0, 0, 0])    # the velocity vector of the Sun
vE = np.array([0, 1, 0])    # the velocity vector of the Earth

dt = 0.1
t_end = 100

xE_vec = [] # x of the Earth
yE_vec = [] # y of the Earth
xS_vec = [] # x of the Sun
yS_vec = [] # y of the Sun

for t in np.linspace(0, t_end, int(t_end/dt)):
     # acc Sun--> Earth
     aE =-G * M * (xE- xS) / np.linalg.norm(xE - xS) ** 3
     # acc Earth--> Sun
     aS =-G * m * (xS- xE) / np.linalg.norm(xS- xE) ** 3
     
      # advance the positions and velocities
     xE = xE + vE * dt
     xS = xS + vS * dt
     vE = vE + aE * dt
     vS = vS + aS * dt
     
     # # advance the positions and velocities
     # vE = vE + aE * dt
     # vS = vS + aS * dt
     # xE = xE + vE * dt
     # xS = xS + vS * dt
     
     
     # store the data for plotting
     xE_vec.append(xE[0])
     yE_vec.append(xE[1])
     xS_vec.append(xS[0])
     yS_vec.append(xS[1])
 
 
# make the plot
fig, axs = plt.subplots()
plt.plot(xE_vec, yE_vec, 'b')
plt.plot(xS_vec, yS_vec, '.',color='tab:orange')
axs.axis('equal')
plt.xlabel('$x$')
plt.ylabel('$y$')
plt.show()